# Swoole\Buffer::substr

(PHP 5 >= 5.2.0, PHP 7, PECL swoole >= 1.9.0)

Swoole\Buffer::substr — Read data from the memory buffer based on offset and length. Or remove data from the memory buffer.

### Description

public Swoole\Buffer::substr ( integer `$offset` [, integer `$length` [, bool `$remove` ]] ) : string

If $remove is set to be true and $offset is set to be 0, the data will be removed from the buffer. The memory for storing the data will be released when the buffer object is deconstructed.

### Parameters

`offset`

  The offset.

`length`

  The length.

`remove`

  Whether to remove the data from the memory buffer.

### Return Values

The data or string readed from the memory buffer.